Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.tiny
Class TinyNodeImpl

    java.lang.Object
      net.sf.saxon.tree.tiny.TinyNodeImpl

All Implemented Interfaces:
  Source, SourceLocator, PullEvent, FingerprintedNode, Item, NodeInfo, ValueRepresentation

Direct Known Subclasses:
  TinyParentNodeImpl, TinyTextImpl, WhitespaceTextImpl

    public abstract class TinyNodeImpl

extends Object
implements NodeInfo, FingerprintedNode, SourceLocator

A node in a TinyTree representing an XML element, character content, or attribute.

This is the top-level class in the implementation class hierarchy; it essentially contains all those methods that can be defined using other primitive methods, without direct access to data.

Author:
  Michael H. Kay

Field Summary
`static char[]` | `NODE_LETTER` Chararacteristic letters to identify each type of node, indexed using the node type values.
`protected int` | `nodeNr`
`protected TinyNodeImpl` | `parent`
`protected TinyTree` | `tree`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`TinyNodeImpl()`

Method Summary
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`boolean` | `equals(Object other)` The equals() method compares nodes for identity.
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node
`String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` | `getBaseURI()` Get the base URI for the node.
`int` | `getColumnNumber()` Get the column number of the node.
`Configuration` | `getConfiguration()` Get the configuration
`int[]` | `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node (a lexical QName).
`long` | `getDocumentNumber()` Get the document number of the document containing this node (Needed when the document isn't a real node, for sorting free-standing elements)
`DocumentInfo` | `getDocumentRoot()` Get the root (document) node
`int` | `getFingerprint()` Get the fingerprint of the node, used for matching names
`int` | `getLineNumber()` Get the line number of the node within its source document entity
`String` | `getLocalPart()` Get the local part of the name of this node.
`int` | `getNameCode()` Get the name code of the node, used for matching names
`NamePool` | `getNamePool()` Get the NamePool for the tree containing this node
`int` | `getNodeNumber()` Get the node number of this node within the TinyTree.
`NodeInfo` | `getParent()` Find the parent node of this node.
`String` | `getPrefix()` Get the prefix part of the name of this node.
`String` | `getPublicId()` Get the public identifier of the document entity containing this node.
`NodeInfo` | `getRoot()` Get the root node of the tree (not necessarily a document node)
`protected long` | `getSequenceNumber()` Get the node sequence number (in document order).
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`String` | `getSystemId()` Get the system ID for the entity containing the node.
`TinyTree` | `getTree()` Get the TinyTree object containing this node
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any
`String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
`boolean` | `isAncestorOrSelf(TinyNodeImpl d)` Test if this node is an ancestor-or-self of another
`boolean` | `isId()` Determine whether this node has the is-id property
`boolean` | `isIdref()` Determine whether this node has the is-idref property
`boolean` | `isNilled()` Determine whether the node has the is-nilled property
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iterator over all the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iterator over the nodes reached by the given axis from this node
`protected void` | `setParentNode(TinyNodeImpl parent)` Set the parent of this node.
`void` | `setSystemId(String uri)` Set the system id of this node.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`atomize, copy, getNodeKind, getStringValue`

Methods inherited from interface net.sf.saxon.om.Item
`getTypedValue`

Field Detail

### tree

    protected TinyTree tree

### nodeNr

    protected int nodeNr

### parent

    protected TinyNodeImpl parent

### NODE_LETTER

    public static final char[] NODE_LETTER

  Chararacteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

Constructor Detail

### TinyNodeImpl

    public TinyNodeImpl()

Method Detail

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

    For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the node. The default implementation returns -1, meaning unknown

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `NodeInfo`
  Returns:
    the column number of the node in its original source document; or -1 if not available

### getPublicId

    public String getPublicId()

  Get the public identifier of the document entity containing this node. The default implementation returns null, meaning unknown

  Specified by:
    `getPublicId` in interface `SourceLocator`

### setSystemId

    public void setSystemId(String uri)

  Set the system id of this node.
  This method is present to ensure that the class implements the javax.xml.transform.Source interface, so a node can be used as the source of a transformation.

  Specified by:
    `setSystemId` in interface `Source`

### setParentNode

    protected void setParentNode(TinyNodeImpl parent)

  Set the parent of this node. Providing this information is useful, if it is known, because otherwise getParent() has to search backwards through the document.

  Parameters:
    `parent` - the parent of this node

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### equals

    public boolean equals(Object other)

  The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().

  Specified by:
    `equals` in interface `NodeInfo`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
  Since:
    8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

### hashCode

    public int hashCode()

  The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()

  Specified by:
    `hashCode` in interface `NodeInfo`
  Overrides:
    `hashCode` in class `Object`
  Since:
    8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

### getSystemId

    public String getSystemId()

  Get the system ID for the entity containing the node.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

### getBaseURI

    public String getBaseURI()

  Get the base URI for the node. Default implementation for child nodes gets the base URI of the parent node.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

### getLineNumber

    public int getLineNumber()

  Get the line number of the node within its source document entity

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getSequenceNumber

    protected long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. The sequence number must be unique within the document (not, as in previous releases, within the whole document collection). For document nodes, elements, text nodes, comment nodes, and PIs, the sequence number is a long with the sequential node number in the top half and zero in the bottom half. The bottom half is used only for attributes and namespace.

  Returns:
    the sequence number

### compareOrder

    public final int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the node, used for matching names

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

### getNameCode

    public int getNameCode()

  Get the name code of the node, used for matching names

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  See Also:
    `allocate`, `getFingerprint`

### getPrefix

    public String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return "".

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, or for an element or attribute in the default namespace, return an empty string.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node (a lexical QName). For elements and attributes this is [prefix:]localname. The original prefix is retained. For unnamed nodes, the result is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getLocalPart

    public String getLocalPart()

  Get the local part of the name of this node.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    The local name of this node. For a node with no name, return "".

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iterator over all the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
  Returns:
    a AxisIteratorImpl that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iterator over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
    `nodeTest` - A pattern to be matched by the returned nodes.
  Returns:
    a AxisIteratorImpl that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getParent

    public NodeInfo getParent()

  Find the parent node of this node.

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    The Node object describing the containing element or root node.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    `true` if this node has any attributes, `false` otherwise.

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node of the tree (not necessarily a document node)

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the root of this tree

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the NamePool for the tree containing this node

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the NamePool

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - buffer, which on return will contain a character string that uniquely identifies this node.

### getDocumentNumber

    public final long getDocumentNumber()

  Get the document number of the document containing this node (Needed when the document isn't a real node, for sorting free-standing elements)

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Returns:
    the document number of the document containing this node

### isAncestorOrSelf

    public boolean isAncestorOrSelf(TinyNodeImpl d)

  Test if this node is an ancestor-or-self of another

  Parameters:
    `d` - the putative descendant-or-self node
  Returns:
    true if this node is an ancestor-or-self of d

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Returns:
    true if the node is an ID

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute

### isNilled

    public boolean isNilled()

  Determine whether the node has the is-nilled property

  Specified by:
    `isNilled` in interface `NodeInfo`
  Returns:
    true if the node has the is-nilled property

### getTree

    public TinyTree getTree()

  Get the TinyTree object containing this node

  Returns:
    the TinyTree. Note that this may also contain other unrelated trees

### getNodeNumber

    public int getNodeNumber()

  Get the node number of this node within the TinyTree. This method is intended for internal use.

  Returns:
    the internal node number

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.